<?php
/**
 * @version $Id: joomag.php,v 2.0.0 $
 * @copyright (C) 2012 Joomag
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.plugin.plugin' );
class plgContentJoomag extends JPlugin
{
    function _j_getValueWithDefault($regex, $params, $default)
    {
        $matchCount = preg_match_all($regex, $params, $matches);
        if ($matchCount) {
            return $matches[1][0];
        } else {
            return $default;
        }
    }

    function onContentPrepare($context, &$article, &$params, $limitStart)
    {
        // For Joomla 1.6
        $this->joomag_parser($article, $params, $limitStart);

    }

    function onPrepareContent(&$article, &$params, $limitStart)
    {
        // For Joomla 1.5
        $this->joomag_parser($article, $params, $limitStart);

    }


    function joomag_parser($row, $params, $page = 0)
    {
        $regex = '/\[joomag ([^]]*)\]/i';
        preg_match_all($regex, $row->text, $matches);
        for ($x = 0; $x < count($matches[0]); $x++) {
            $replace = $this->joomag_get_magazine($matches[0][$x]);
            $row->text = str_replace($matches[0][$x], $replace, $row->text);
        }

        $regex = '/\[joomag_bookshelf ([^]]*)\]/i';
        preg_match_all($regex, $row->text, $matches);
        for ($x = 0; $x < count($matches[0]); $x++) {
            $replace = $this->joomag_get_bookshelf($matches[0][$x]);
            $row->text = str_replace($matches[0][$x], $replace, $row->text);
        }
    }

    function joomag_get_bookshelf($matches)
    {
        $matches = str_replace("&nbsp;", ' ', htmlentities($matches));

        $allowFullScreen = $this->_j_getValueWithDefault('/(?:^|[\s]+)allowfullscreen=([\S]*)/i', $matches, 1);
        $height = $this->_j_getValueWithDefault('/(?:^|[\s]+)height=([\S]*)/i', $matches, 460);
        $width = $this->_j_getValueWithDefault('/(?:^|[\s]+)width=([\S]*)/i', $matches, 450);
        $magazineId = $this->_j_getValueWithDefault('/(?:^|[\s]+)magazineId=([\S]*)/i', $matches, '');
        $title = $this->_j_getValueWithDefault('/(?:^|[\s]+)title=([\S]*)/i', $matches, '');
        $cols = $this->_j_getValueWithDefault('/(?:^|[\s]+)cols=([\S]*)/i', $matches, 3);
        $rows = $this->_j_getValueWithDefault('/(?:^|[\s]+)rows=([\S]*)/i', $matches, 2);
        $version = $this->_j_getValueWithDefault('/(?:^|[\s]+)version=([\S]*)/i', $matches, 1);
        $minHeight = $this->_j_getValueWithDefault('/(?:^|[\s]+)minHeight=([\S]*)/i', $matches, 6);
        $publicationsCount = $this->_j_getValueWithDefault('/(?:^|[\s]+)publicationsCount=([\S]*)/i', $matches, 6);
        $showTitles = $this->_j_getValueWithDefault('/(?:^|[\s]+)showTitles=([\S]*)/i', $matches, 0);
        $showEditions = $this->_j_getValueWithDefault('/(?:^|[\s]+)showEditions=([\S]*)/i', $matches, 0);
        $theme = $this->_j_getValueWithDefault('/(?:^|[\s]+)theme=([\S]*)/i', $matches, 'image');

        $domain = 'www.joomag.com';

        if ($version == 1) {
            // Old version with columns and rows
            $embedCodeStr = '<iframe ${allowfullscreen} name="Joomag_embed_${UUID}"' .
                ' style="width:${width};height:${height}" width="${width}" height="${height}" hspace="0" vspace="0" frameborder="0" ' .
                ' src="${bookshelfURL}&cols=${cols}&rows=${rows}"></iframe>';

            $bookshelfURL = '//' . $domain . '/Frontend/embed/bookshelf/index.php?UID=' . $magazineId;
        } else {
            $embedCodeStr = '<iframe ${allowfullscreen} name="Joomag_embed_${UUID}"' .
                ' style="width:${width};height:${height};min-height:${minHeight};" width="${width}" height="${height}" hspace="0" vspace="0" frameborder="0" ' .
                ' src="${bookshelfURL}&publicationsCount=${publicationsCount}&showTitles=${showTitles}&showEditions=${showEditions}&theme=${theme}"></iframe>';

            $bookshelfURL = '//' . $domain . '/Frontend/embed/bookshelf/v2.php?UID=' . $magazineId;
        }

        $UUID = sprintf('%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
            mt_rand(0, 0xffff), mt_rand(0, 0xffff),
            mt_rand(0, 0xffff),
            mt_rand(0, 0x0fff) | 0x4000,
            mt_rand(0, 0x3fff) | 0x8000,
            mt_rand(0, 0xffff), mt_rand(0, 0xffff), mt_rand(0, 0xffff)
        );

        $allowfullscreenReplace = '';

        if ($allowFullScreen == 1) {
            $allowfullscreenReplace = 'allowfullscreen="allowfullscreen"';
        }

        $embedCodeStr = str_replace(
            '${width}',
            strpos($width, '%') == false ? "{$width}px" : $width,
            $embedCodeStr
        );

        $embedCodeStr = str_replace(
            '${height}',
            strpos($height, '%') == false ? "{$height}px" : $height,
            $embedCodeStr
        );

        $embedCodeStr = str_replace('${allowfullscreen}', $allowfullscreenReplace, $embedCodeStr);
        $embedCodeStr = str_replace('${bookshelfURL}', $bookshelfURL, $embedCodeStr);
        $embedCodeStr = str_replace('${minHeight}', $minHeight . 'px', $embedCodeStr);
        $embedCodeStr = str_replace('${cols}', $cols, $embedCodeStr);
        $embedCodeStr = str_replace('${rows}', $rows, $embedCodeStr);
        $embedCodeStr = str_replace('${publicationsCount}', $publicationsCount, $embedCodeStr);
        $embedCodeStr = str_replace('${showTitles}', $showTitles, $embedCodeStr);
        $embedCodeStr = str_replace('${showEditions}', $showEditions, $embedCodeStr);
        $embedCodeStr = str_replace('${theme}', $theme, $embedCodeStr);
        $embedCodeStr = str_replace('${UUID}', $UUID, $embedCodeStr);

        return $embedCodeStr;
    }

    function joomag_get_magazine($matches)
    {
        $matches = str_replace("&nbsp;", ' ', htmlentities($matches));

        $allowFullScreen	 =	$this->_j_getValueWithDefault('/(?:^|[\s]+)allowfullscreen=([\S]*)/i', $matches, 1);
        $height				 =	$this->_j_getValueWithDefault('/(?:^|[\s]+)height=([\S]*)/i', $matches, 272);
        $width				 =	$this->_j_getValueWithDefault('/(?:^|[\s]+)width=([\S]*)/i', $matches, 420);
        $pageNumber			 =	$this->_j_getValueWithDefault('/(?:^|[\s]+)pageNumber=([\S]*)/i', $matches, 1);
        $magazineId			 =	$this->_j_getValueWithDefault('/(?:^|[\s]+)magazineId=([\S]*)/i', $matches, '');
        $title				 =	$this->_j_getValueWithDefault('/(?:^|[\s]+)title=([\S]*)/i', $matches, '');
        $backgroundColor	 =	$this->_j_getValueWithDefault('/(?:^|[\s]+)backgroundColor=([\S]*)/i', $matches, '');
        $backgroundImg		 =	$this->_j_getValueWithDefault('/(?:^|[\s]+)backgroundImage=([\S]*)/i', $matches, '');
        $toolbar		     =	$this->_j_getValueWithDefault('/(?:^|[\s]+)toolbar=([\S]*)/i', $matches, '');
        $autoFlip		     =	$this->_j_getValueWithDefault('/(?:^|[\s]+)autoFlip=([\S]*)/i', $matches, '');
        $autoFit			 =	$this->_j_getValueWithDefault('/(?:^|[\s]+)autoFit=([\S]*)/i', $matches, 'false') == 'true' ? true : false;
		$theme				 =	$this->_j_getValueWithDefault('/(?:^|[\s]+)theme=([\S]*)/i', $matches, '');

        $embedCodeStr =  '<IFRAME ${allowfullscreen} NAME="Joomag_embed_${UUID}"'.
                         ' style="width:${width};height:${height}" WIDTH="${width}" HEIGHT="${height}" HSPACE="0" VSPACE="0" frameborder="0" '.
                         ' SRC="${magURL}?page=${startPage}&e=1${otherOptions}"></IFRAME>' ;

        $allowfullscreenReplace = '';

        if ($allowFullScreen == 1) {
            $allowfullscreenReplace = 'allowfullscreen="allowfullscreen"';
        }

        $embedCodeStr = str_replace('${allowfullscreen}', $allowfullscreenReplace, $embedCodeStr);

        $domain = 'www.joomag.com';

        $viewerURL = '//' . $domain . '/magazine/' . $title . '/' . $magazineId;

        $embedOpts = array();
        if($toolbar != '')
        {
            switch( $toolbar ) {
                case 'none':
                    array_push($embedOpts, 'noToolbar');
                    break;
                case 'transparent':
                    array_push($embedOpts, 'none');
                    break;
                default:
                    array_push($embedOpts, "solid,{$toolbar}");
                    break;
            }
        } elseif ( $theme != '') {
			array_push($embedOpts, "theme,{$theme}");
		} else {
			array_push($embedOpts, '');
		}

        if($backgroundColor != '')
        {
            $bgColors = explode(',', $backgroundColor);

            if( $backgroundColor == 'transparent' ) {
                array_push($embedOpts, 'none');
            } elseif( is_array($bgColors) && count($bgColors) == 2 ) {
                array_push($embedOpts, "gradient,{$backgroundColor}");
            } else {
                array_push($embedOpts, "solid,{$backgroundColor}");
            }
        } else if( $backgroundImg != '' ) {
            array_push($embedOpts, "image,{$backgroundImg},fill");
        } else {
            array_push($embedOpts, '');
        }

        $embedOptsStr = '&embedInfo=' . implode(';', $embedOpts);
        if( is_numeric($autoFlip) ) {
            $embedOptsStr .= "&autoFlipDelay={$autoFlip}";
        }

        if( $autoFit == true ) {
            $embedCodeStr = str_replace('${width}', '100%', $embedCodeStr);
            $embedCodeStr = str_replace('${height}', '100%', $embedCodeStr);}
        else {
            $embedCodeStr = str_replace('${width}', $width.'px', $embedCodeStr);
            $embedCodeStr = str_replace('${height}', $height.'px', $embedCodeStr);
        }

        $embedCodeStr = str_replace('${startPage}', $pageNumber, $embedCodeStr);

        $embedCodeStr = str_replace('${otherOptions}', $embedOptsStr, $embedCodeStr);

        $UUID = sprintf('%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
            mt_rand(0, 0xffff), mt_rand(0, 0xffff),
            mt_rand(0, 0xffff),
            mt_rand(0, 0x0fff) | 0x4000,
            mt_rand(0, 0x3fff) | 0x8000,
            mt_rand(0, 0xffff), mt_rand(0, 0xffff), mt_rand(0, 0xffff)
        );

        $embedCodeStr = str_replace('${magURL}', $viewerURL, $embedCodeStr);
        $embedCodeStr = str_replace('${UUID}', $UUID, $embedCodeStr);

        return $embedCodeStr;
    }

}
?>
